#ifndef _DBIS_XML_PARSE_H_
#define _DBIS_XML_PARSE_H_

#include "xmlParser/xmlparse.h"
#include "Stack.h"
#include "porter.h"
#include "UrlDocMap.h"
#include "Index5.h"

#define MAX_LINE_SIZE 2048


/* Statistics
   typedef struct _perfMon {
   double _parseTime;
   double _insertTime;
   double _writeTime;
   double _mergeTime;
   } perfMon;
   */

class Indexer {
private:
  /* Statistics
     int   _pathCount;
     int   _nodeCount;
     int   _wordLenTot;
     int   _pathLenTot;
     int   _fanOutTot;
     int   _depth;
     int   _depthTot;
     bool  _newPath;
     */  

  static Stack _elmntStk;
  static char* _path;

  static XML_Parser _parser;

  static Index* _index;
  static UrlDocMap* _url_docid_map;
  static int _docid_url_map;

  static char* _fname;

  static int   _docCount;  
  static int   _wordCount;
public:
  static void init(char *fname_);
  static void cleanup();
  
  /* Functions: startElement, endElement, charElement
  ** Handlers for the XML parser generated events
  */
  static void startElement(void *userData_, const char *name_, const char **atts_);
  static void endElement(void *userData_, const char *name_);
  static void charElement(void *userData_, const char *name_, int len_);
  
  /* Function: parseAndIndex
  ** Parse the file and create an inverted index for it 
  ** Parameters:
  **        1. name of file to index
  **        2. url corresponding to that file
  ** Return Value:
  **        -1 if there is any error
  **        0  otherwise
  */
  static int   parseAndIndex(char *fname_, char *url_); 
};


#endif //_DBIS_XML_PARSE_H_
