#ifndef LINEAR_HASH
#define LINEAR_HASH

#include "List.h"

typedef struct HashFileHeader_ {
  int _num_slots;
  int _num_bkts;
  int _recd_size;
} HashFileHeader;

template <class key_type, class data_type, class record_type>
class LinearHash {
  int   _file_desc;
  char* _file_name;
  char* _idString;
  HashFileHeader _fheader;
  List<record_type, key_type> **_lists;
  List<record_type, key_type> **_temp;
  int _lists_occupancy;

  int find_bkt(char *key_);
  int goto_bkt(int bktnum_);
  int my_write(int fd_, char *buf_, int nbytes_);
  int my_read(int fd_, char *buf_, int nbytes_);
public:
  LinearHash(char *fname_, int num_bkts_, int num_slots_, int rec_len_, char *idString_ = "LH3: ");
  LinearHash(const LinearHash& other_);
  ~LinearHash();

  int find(key_type key_, data_type &data_, bool &found_);
  int remove(key_type key_);
  int insert(record_type record_, double &cpu_time_, double &disk_time_);
  int update(record_type record_);
  int flush_to_disk();
};

#endif
