#ifndef list_h
#define list_h

#include <iostream.h>
#include <assert.h>

template <class listitem>
struct listNode {
  listitem data;
  struct listNode<listitem> *next;
};

template <class listitem, class datakey>
class List {
  struct listNode<listitem> *first, *last;
  struct listNode<listitem> *puppy, *curr;
  int count;

public:
  List();
  List(const List&);
  ~List();
  
  List& operator =(const List&);
  
  void goFirst();
  void goLast();
  void goNext();
  bool find(datakey);

  bool isOffList() const;
  bool isEmpty() const;
    
  void addToBack(listitem);
  void insert(listitem);
  void insert_replace(listitem);

  bool delFirst();
  bool delCurr();
  
  listitem getFromCurrent() const;
  
  List operator +(List& other); /* intersection */
  List& operator -(List& other); /* difference   */

  List& merge     (List& other); /* merge        */

  /*void printList(ostream&);*/

  int  length() { return count; }

  /*private:*/
  void free();
};
#endif

