#ifndef TIME_H
#define TIME_H
#include <fstream.h>

#define TIME_SIZE (2 * (sizeof(long)))
class Time {
  long _sec;
  long _usec;
public:
  Time(char *ptr_=0);
  Time(long sec_, long usec_);
  Time(const Time& other_);
  ~Time();

  char* toCharPtr();
  int get_len();
  static int get_max_len();
  friend ostream& operator <<(ostream& out_, Time t_);
  bool operator <=(const Time& other_);
  bool operator >=(const Time& other_);
  bool operator <(const Time& other_);
  bool operator >(const Time& other_);
  bool operator ==(const Time& other_);
  Time& operator =(const Time& rhs_);
};
#endif
