/* Author: Thomas Baby
   School: UMCP
   Date: Winter 2000
   
   Trie class
   */

#ifndef Trie_h
#define Trie_h
#include <iostream.h>
#include "InvList.h"
#include "String.h"
#include <stdio.h>
#include "Int.h"

typedef struct _TrieNode {
  char letter;
  InvList *list;
  int size;
  struct _TrieNode *next;
  struct _TrieNode *child;
} TrieNode;

class Trie
{
private:
  TrieNode *_root; /* pointer to the leftmost node at the root level */
  int _num_entries; /* size of Trie */

  void get_all_words_helper(char*, TrieNode *, List<String, String>&);

  void freeHelp(TrieNode *);
  
  void compute_sizes_helper(TrieNode *node_ptr_);
public:
  Trie();
  ~Trie();
  
  int  insert(String word_, String pname_, int doc_id_, int word_posn_);
  
  void compute_sizes();

  bool find(String word_, InvList& list_);

  List<String, String> *get_all_words();

  int getTrieSize() const;
  
  int get_size(String word_);

};

#endif Trie_h


